program UniDAC_Linux;
{$APPTYPE CONSOLE}
{$R *.res}
uses
  SysUtils,
  Uni,
  ASEUniProvider,         // add this unit for ASE
  DBFUniProvider,         // add this unit for DBF
  MongoDBUniProvider,     // add this unit for MongoDB
  MySQLUniProvider,       // add this unit for MySQL
  OracleUniProvider,      // add this unit for Oracle
  PostgreSQLUniProvider,  // add this unit for PostgreSQL
  SQLiteUniProvider,      // add this unit for SQLite
  SQLServerUniProvider;   // add this unit for SQL Server & SQL Azure

procedure SQLite_Create_EMP(AQuery: TUniQuery);
const
  CREATE_EMP_SQL =
    ' CREATE TABLE EMP ( ' +
    ' EMPNO INTEGER NOT NULL, ' +
    ' ENAME VARCHAR(10), ' +
    ' JOB VARCHAR(9), ' +
    ' MGR INTEGER, ' +
    ' HIREDATE TIMESTAMP, ' +
    ' SAL REAL, ' +
    ' COMM REAL, ' +
    ' DEPTNO INT, ' +
    ' PRIMARY KEY (EMPNO) ' +
  ' ); ';
begin
  AQuery.SQL.Text := CREATE_EMP_SQL;
  AQuery.ExecSQL;
end;

procedure SQLite_Insert_EMP(AQuery: TUniQuery);
const
  INSERT_EMP_SQL =
  ' INSERT INTO EMP VALUES (7369,''SMITH'',''CLERK'',7902,''1980-12-17'',800,NULL,20); ' +
  ' INSERT INTO EMP VALUES (7499,''ALLEN'',''SALESMAN'',7698,''1981-2-20'',1600,300,30); ' +
  ' INSERT INTO EMP VALUES (7521,''WARD'',''SALESMAN'',7698,''1981-2-22'',1250,500,30); ' +
  ' INSERT INTO EMP VALUES (7566,''JONES'',''MANAGER'',7839,''1981-4-2'',2975,NULL,20); ' +
  ' INSERT INTO EMP VALUES (7654,''MARTIN'',''SALESMAN'',7698,''1981-9-28'',1250,1400,30); ' +
  ' INSERT INTO EMP VALUES (7698,''BLAKE'',''MANAGER'',7839,''1981-5-1'',2850,NULL,30); ' +
  ' INSERT INTO EMP VALUES (7782,''CLARK'',''MANAGER'',7839,''1981-6-9'',2450,NULL,10); ' +
  ' INSERT INTO EMP VALUES (7788,''SCOTT'',''ANALYST'',7566,''1987-7-13'',3000,NULL,20); ' +
  ' INSERT INTO EMP VALUES (7839,''KING'',''PRESIDENT'',NULL,''1981-11-17'',5000,NULL,10); ' +
  ' INSERT INTO EMP VALUES (7844,''TURNER'',''SALESMAN'',7698,''1981-9-8'',1500,0,30); ' +
  ' INSERT INTO EMP VALUES (7876,''ADAMS'',''CLERK'',7788,''1987-7-13'',1100,NULL,20); ' +
  ' INSERT INTO EMP VALUES (7900,''JAMES'',''CLERK'',7698,''1981-12-3'',950,NULL,30); ' +
  ' INSERT INTO EMP VALUES (7902,''FORD'',''ANALYST'',7566,''1981-12-3'',3000,NULL,20); ' +
  ' INSERT INTO EMP VALUES (7934,''MILLER'',''CLERK'',7782,''1982-1-23'',1300,NULL,10); ';
begin
  AQuery.SQL.Text := INSERT_EMP_SQL;
  AQuery.ExecSQL;
end;

procedure MongoDB_Insert_EMP(AQuery: TUniQuery);
const
  INSERT_EMP_SQL = '{"insert":"emp", documents:[' +
  ' {"empno":"7369","ename":"SMITH","job":"CLERK","hiredate":"1980-12-17"},' +
  ' {"empno":"7499","ename":"ALLEN","job":"SALESMAN","hiredate":"1981-2-20"},' +
  ' {"empno":"7521","ename":"WARD","job":"SALESMAN","hiredate":"1981-2-22"},' +
  ' {"empno":"7566","ename":"JONES","job":"MANAGER","hiredate":"1981-4-2"},' +
  ' {"empno":"7654","ename":"MARTIN","job":"SALESMAN","hiredate":"1981-9-28"},' +
  ' {"empno":"7698","ename":"BLAKE","job":"MANAGER","hiredate":"1981-5-1"},' +
  ' {"empno":"7782","ename":"CLARK","job":"MANAGER","hiredate":"1981-6-9"},' +
  ' {"empno":"7788","ename":"SCOTT","job":"ANALYST","hiredate":"1987-7-13"},' +
  ' {"empno":"7839","ename":"KING","job":"PRESIDENT","hiredate":"1981-11-17"},' +
  ' {"empno":"7844","ename":"TURNER","job":"SALESMAN","hiredate":"1981-9-8"},' +
  ' {"empno":"7876","ename":"ADAMS","job":"CLERK","hiredate":"1987-7-13"},' +
  ' {"empno":"7900","ename":"JAMES","job":"CLERK","hiredate":"1981-12-3"},' +
  ' {"empno":"7902","ename":"FORD","job":"ANALYST","hiredate":"1981-12-3"},' +
  ' {"empno":"7934","ename":"MILLER","job":"CLERK","hiredate":"1982-1-23"}' +
  ']}';
begin
  AQuery.SQL.Text := INSERT_EMP_SQL;
  AQuery.ExecSQL;
end;

procedure WritelnQuery(AQuery: TUniQuery; ASQL: string);
var
  i: integer;
begin
  Writeln('------------------------------------------------------');
  AQuery.SQL.Text := ASQL;
  AQuery.Open;
  while (not AQuery.Eof) do begin
    for i := 0 to AQuery.FieldCount - 1 do
      if (i = 0) then
        Write(Format('%-10s', [AQuery.Fields[i].AsString]))
      else
        Write(Format(' | %-10s', [AQuery.Fields[i].AsString]));
    Writeln;
    AQuery.Next;
  end;
end;

var
  UniConnection: TUniConnection;
  UniQuery: TUniQuery;
begin
  UniConnection := TUniConnection.Create(nil);

  UniQuery := TUniQuery.Create(nil);
  UniQuery.Connection := UniConnection;

  UniConnection.ProviderName := 'ASE';
  UniConnection.SpecificOptions.Values['Direct'] := 'True';
  UniConnection.Server := 'ASE_DB';
  UniConnection.Port := 5000;
  UniConnection.Username := 'sa';
  UniConnection.Password := '*****';
  UniConnection.Database := 'DEMO';
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC ASE Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select @@version');
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'DBF';
  UniConnection.Server := '192.168.0.60';
  UniConnection.SpecificOptions.Values['DBFFormat'] := 'dfdBaseVII';
  UniConnection.SpecificOptions.Values['Direct'] := 'True';
  UniConnection.Database := '/home/test/Documents';
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC DBF Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'MongoDB';
  UniConnection.Server := 'MongoDBServer';
  UniConnection.Port := 27017;
  UniConnection.SpecificOptions.Values['BSONLibrary'] := '/usr/lib64/libbson-1.0.so';
  UniConnection.SpecificOptions.Values['ClientLibrary'] := '/usr/lib64/libmongoc-1.0.so';
  UniConnection.Database := 'demo';
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC MongoDB Provider ==--'+#13#10);
  Writeln(UniConnection.ServerVersionFull);
  MongoDB_Insert_EMP(UniQuery);
  WritelnQuery(UniQuery, '{"find":"emp", projection:{_id:0, empno:1, ename:1, job:1, hiredate:1}}');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'MySQL';
  UniConnection.Server := 'MySQL_db';
  UniConnection.Port := 3312;
  UniConnection.Username := 'root';
  UniConnection.Password := '*****';
  UniConnection.Database := 'demo';
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC MySQL Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select @@version');
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'Oracle';
  UniConnection.SpecificOptions.Values['Direct'] := 'True';
  UniConnection.Server := 'ORCL12C:1521/pdborcl';
  UniConnection.Username := 'scott';
  UniConnection.Password := '******';
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC Oracle Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select * from v$version');
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'PostgreSQL';
  UniConnection.Server := 'pg_db';
  UniConnection.Database := 'demo';
  UniConnection.Username := 'postgres';
  UniConnection.Password := '******';
  UniConnection.Port := 5432;
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC PostgreSQL Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select version()');
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'SQLite';
  UniConnection.SpecificOptions.Values['Direct'] := 'True';
  UniConnection.SpecificOptions.Values['ForceCreateDatabase'] := 'True';
  UniConnection.Database := ':memory:';
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC SQLite Provider ==--'+#13#10);
  Writeln(UniConnection.ServerVersionFull);
  SQLite_Create_EMP(UniQuery);
  SQLite_Insert_EMP(UniQuery);
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'SQL Server';
  UniConnection.SpecificOptions.Values['Provider'] := 'prDirect';
  UniConnection.Server := 'qps1hrvdke.database.windows.net';
  UniConnection.Database := 'DEMO';
  UniConnection.Username := '****@qps1hrvdke';
  UniConnection.Password := '*******';
  UniConnection.Port := 1433;
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC SQL Server(Azure) Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select @@version');
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  UniConnection.Disconnect;
  UniConnection.ProviderName := 'SQL Server';
  UniConnection.SpecificOptions.Values['Provider'] := 'prDirect';
  UniConnection.Server := '192.168.0.15\MSSQL2016';
  UniConnection.Database := 'DEMO';
  UniConnection.Username := 'sa';
  UniConnection.Password := '*****';
  UniConnection.Port := 1433;
  UniConnection.Connect;
  Writeln(#13#10+'--== UniDAC SQL Server Provider ==--'+#13#10);
  WritelnQuery(UniQuery, 'select @@version');
  WritelnQuery(UniQuery, 'select empno, ename, job, hiredate from emp');

  Readln;

end.
